%define name tmda-cgi
%define version 0.16.4
%define release 8.kg3

%define pypath %(if [ `type -p python2` ]; then type -p python2; else type -p python; fi)
%define pyprefix %(%pypath -c 'import sys; print sys.prefix')
%define pyver %(%pypath -c 'import sys; print sys.version[:3]')
%define pylibdir %{pyprefix}/lib/python%{pyver}/site-packages
%define cgidir %{pylibdir}/TMDA/cgi
%define httpdconfdir %{_sysconfdir}/httpd/conf.d

Summary: Tagged Message Delivery Agent, CGI Interface
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
SOURCE0: tmda-fork-master.tar.gz
SOURCE2: login.gif
SOURCE11: bounce_expired_dated.txt
SOURCE12: bounce_fail_dated.txt
SOURCE13: bounce_fail_keyword.txt
SOURCE14: bounce_fail_sender.txt
SOURCE15: bounce_incoming.txt
SOURCE16: bounce_invalid_confirmation.txt
SOURCE17: bounce_missing_pending.txt
SOURCE18: confirm_accept.txt
SOURCE19: confirm_request.txt
Patch0: skel.patch
License: GPL
Group: Utilities/System
BuildRoot: %{_tmppath}/%{name}-buildroot
Vendor: Gre7g Luterman <gre7g@wolfhome.com>
Packager: tmda-workers@tmda.net
Url: http://tmda.net/tmda-cgi/
BuildRequires: /usr/bin/python2
BuildRequires: tmda >= 1.1.12
Requires: /usr/bin/python2, tmda >= 1.1.0, httpd

%description
TMDA is an OSI certified software application designed to
significantly reduce the amount of SPAM/UCE (junk-mail) you receive.
This subpackage is the CGI interface to TMDA.

%prep
%setup -q -n tmda-fork-master

cd tmda-cgi
%patch0 -p0

%build
rm -rf %{buildroot}

# fix shbang line in all executable files
find . -type f -perm 0755 -print | while read i
do
  sed '1,1s|/usr/bin/env python|%pypath|g' $i > $i.tmp && mv $i.tmp $i && chmod 0755 $i
done

cd tmda-cgi

%{pypath} configure                        \
    --base-dir %{pylibdir}                 \
    --display-dir ./display                \
    --mode system-wide                     \
    --virtual-lookup None                  \
    --remote-auth pop3://localhost         \
    --session-prefix /tmp/                 
cat tmda-cgi.h | sed -e 's@define INSTALL .*@define INSTALL   "/usr/lib/python%{pyver}/site-packages/TMDA/cgi/"@' > tmda-cgi.h.new
mv tmda-cgi.h.new tmda-cgi.h
cat <<_END_ >> Makefile
tmda-cgi: tmda-cgi.h
	cc -I . tmda-cgi.c -o tmda.cgi
_END_
make

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/var/cache/tmda-cgi
mkdir -p %{buildroot}%{cgidir}/display
mkdir -p %{buildroot}%{httpdconfdir}
cd tmda-cgi
install *.{py,pyc} %{buildroot}%{cgidir}
install tmda.cgi %{buildroot}%{cgidir}
install defaults.ini %{buildroot}%{cgidir}
install THANKS %{buildroot}%{cgidir}
install TODO %{buildroot}%{cgidir}
cp -r display %{buildroot}%{cgidir}
cat tmda-cgi.conf | sed -e 's|SITE_DIR|%{cgidir}|' > %{buildroot}%{httpdconfdir}/tmda-cgi.conf

# autoinstall skel directory.
(mkdir -p $RPM_BUILD_ROOT/usr/lib/python%{pyver}/site-packages/TMDA/cgi/skel;
cp -r skel $RPM_BUILD_ROOT/usr/lib/python%{pyver}/site-packages/TMDA/cgi/;
)

# Fix login graphic by overwriting corrupted file.
cp %{SOURCE2} %{buildroot}/usr/lib/python%{pyver}/site-packages/TMDA/cgi/display/themes/Blue

# Fix tmda-fork-master templates by deleting and copying SOURCEZZZ files from
# tmda-cgi-0.16.4.
rm -rf %{buildroot}/usr/lib/python%{pyver}/site-packages/TMDA/cgi/skel/install/.tmda/templates/*
cp %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} %{SOURCE15} %{SOURCE16} %{SOURCE17} %{SOURCE18} %{SOURCE19} %{buildroot}/usr/lib/python%{pyver}/site-packages/TMDA/cgi/skel/install/.tmda/templates/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{cgidir}/display/*
%attr(0700,root,root) %dir /var/cache/tmda-cgi
%{cgidir}/*.py
%{cgidir}/*.pyo
%{cgidir}/skel
%{cgidir}/THANKS
%{cgidir}/TODO
%config(noreplace) %{cgidir}/defaults.ini
%verify(not size md5 mtime) %{cgidir}/*.pyc
%attr(4755,root,root) %{cgidir}/tmda.cgi
%config(noreplace) %{httpdconfdir}/tmda-cgi.conf
%doc tmda-cgi/README tmda-cgi/THANKS tmda-cgi/TODO tmda-cgi/UPGRADE tmda-cgi/htdocs/*.html tmda-cgi/htdocs/display/* tmda-cgi/htdocs/display/dyn_buttons/*

%post
service httpd reload > /dev/null 2>&1 || :

%postun
service httpd reload > /dev/null 2>&1 || :

%changelog
* Mon Apr 20 2018 David Summers <david@summersoft.fay-ar.us> 0.16.4-8.kg3
- Updated build generation, no logic changes.
- Also tested to work on both CentOS 6 and CentOS 7.

* Sat Nov 30 2013 David Summers <david@summersoft.fay-ar.us> 0.16.4-7.kg3
- Fix for postfix file creation.

* Fri Nov 29 2013 David Summers <dsummers@digital-realms.com> 0.16.4-6.kg3
- Consolidated tmda and tmda-cgi since they use the same tar file.
  No other changes (yet).

* Fri Nov 23 2012 David Summers <dsummers@digital-realms.com> 0.16.4-5.kg3
- Updated to RHEL6.
- This uses KevenGoodsell version kg3.
- Had to copy 0.16.4 templates in place of the kg3 versions for some reason.

* Sat Dec 01 2007 David Summers <dsummers@digital-realms.com> 0.16.4-4.dws
- Took out special skel.tar.gz install file as not needed any more.
  Patched skel config directory to put debug.log and incoming/outgoing.log in
  the .tmda directory.

* Wed Nov 28 2007 David Summers <dsummers@digital-realms.com> 0.16.4-3.dws
- Fixed login graphic.
- Fixed *.pyo files to build. In future need to find out why some boxes
  are not building the *.pyo files and others are.
- Fixed to install to clean buildroot.
- Took out unneeded patches and commented out previous configure statement.

* Wed Nov 28 2007 David Summers <dsummers@digital-realms.com> 0.16.4-2.dws
- Fixed packaging of *.pyo files. (Needed on RHEL5).
- Also fixed template files to be correct.

* Sat Oct 13 2007 David Summers <dsummers@digital-realms.com> 0.16.4-1
- Updated to 0.16.4.
- Updated default config to use INBOX.Pending the default pending queue for
  TMDA users.

* Mon Dec 26 2005 David Summers <dsummers@digital-realms.com> 0.12-2
- Updated for RHEL4 (uses python 2.3). Made it where the python version is
  automatically detected.

* Sun Feb 29 2004 David Summers <dsummers@digital-realms.com> 0.12-1
- Rebuilt for RedHat 9.
- Added auto-install skel directory.


* Fri Apr 25 2003 Bernard Johnson <bjohnson@symetrix.com>
  - initial RPM of tmda-cgi 0.06 (outside of previous RPMS packaged with TMDA)
